<center><a href="ex1.c">Actual source code: ex1.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:21:16+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80">
<a name="line2">  2: </a>static char help[] = <font color="#666666">"Creating a general index set.\n\n"</font>;

<a name="line4">  4: </a><font color="#B22222">/*T</font>
<a name="line5">  5: </a><font color="#B22222">    Concepts: index sets^manipulating a general index set;</font>
<a name="line6">  6: </a><font color="#B22222">    Concepts: index sets^creating general;</font>
<a name="line7">  7: </a><font color="#B22222">    Concepts: <A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A>^creating a general index set;</font>

<a name="line9">  9: </a><font color="#B22222">    Description: Creates an index set based on a set of integers. Views that index set</font>
<a name="line10"> 10: </a><font color="#B22222">    and then destroys it.</font>
<a name="line11"> 11: </a><font color="#B22222">    </font>
<a name="line12"> 12: </a><font color="#B22222">T*/</font>
<a name="line13"> 13: </a>
<a name="line14"> 14: </a><font color="#B22222">/*</font>
<a name="line15"> 15: </a><font color="#B22222">    Include petscis.h so we can use PETSc <A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A> objects. Note that this automatically </font>
<a name="line16"> 16: </a><font color="#B22222">  includes petsc.h.</font>
<a name="line17"> 17: </a><font color="#B22222">*/</font>
<a name="line18"> 18: </a> #include <A href="../../../../../include/petscis.h.html">petscis.h</A>

<a name="line22"> 22: </a><strong><font color="#4169E1"><a name="main"></a>int main(int argc,char **argv)</font></strong>
<a name="line23"> 23: </a>{
<a name="line25"> 25: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       *indices,n;
<a name="line26"> 26: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMPIInt.html#PetscMPIInt">PetscMPIInt</A>    <A href="../../../../../docs/manualpages/Sys/rank.html#rank">rank</A>;
<a name="line27"> 27: </a>  <A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A>             is;

<a name="line29"> 29: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInitialize.html#PetscInitialize">PetscInitialize</A>(&amp;argc,&amp;argv,(char*)0,help);
<a name="line30"> 30: </a>  <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Comm_rank.html#MPI_Comm_rank">MPI_Comm_rank</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;<A href="../../../../../docs/manualpages/Sys/rank.html#rank">rank</A>);

<a name="line32"> 32: </a>  <font color="#B22222">/*</font>
<a name="line33"> 33: </a><font color="#B22222">     Create an index set with 5 entries. Each processor creates</font>
<a name="line34"> 34: </a><font color="#B22222">   its own index set with its own list of integers.</font>
<a name="line35"> 35: </a><font color="#B22222">  */</font>
<a name="line36"> 36: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(5*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;indices);
<a name="line37"> 37: </a>  indices[0] = <A href="../../../../../docs/manualpages/Sys/rank.html#rank">rank</A> + 1;
<a name="line38"> 38: </a>  indices[1] = <A href="../../../../../docs/manualpages/Sys/rank.html#rank">rank</A> + 2;
<a name="line39"> 39: </a>  indices[2] = <A href="../../../../../docs/manualpages/Sys/rank.html#rank">rank</A> + 3;
<a name="line40"> 40: </a>  indices[3] = <A href="../../../../../docs/manualpages/Sys/rank.html#rank">rank</A> + 4;
<a name="line41"> 41: </a>  indices[4] = <A href="../../../../../docs/manualpages/Sys/rank.html#rank">rank</A> + 5;
<a name="line42"> 42: </a>  <A href="../../../../../docs/manualpages/IS/ISCreateGeneral.html#ISCreateGeneral">ISCreateGeneral</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,5,indices,&amp;is);
<a name="line43"> 43: </a>  <font color="#B22222">/*</font>
<a name="line44"> 44: </a><font color="#B22222">     Note that <A href="../../../../../docs/manualpages/IS/ISCreateGeneral.html#ISCreateGeneral">ISCreateGeneral</A>() has made a copy of the indices</font>
<a name="line45"> 45: </a><font color="#B22222">     so we may (and generally should) free indices[]</font>
<a name="line46"> 46: </a><font color="#B22222">  */</font>
<a name="line47"> 47: </a>  <A href="../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(indices);

<a name="line49"> 49: </a>  <font color="#B22222">/*</font>
<a name="line50"> 50: </a><font color="#B22222">     Print the index set to stdout</font>
<a name="line51"> 51: </a><font color="#B22222">  */</font>
<a name="line52"> 52: </a>  <A href="../../../../../docs/manualpages/IS/ISView.html#ISView">ISView</A>(is,<A href="../../../../../docs/manualpages/Viewer/PETSC_VIEWER_STDOUT_SELF.html#PETSC_VIEWER_STDOUT_SELF">PETSC_VIEWER_STDOUT_SELF</A>);

<a name="line54"> 54: </a>  <font color="#B22222">/*</font>
<a name="line55"> 55: </a><font color="#B22222">     Get the number of indices in the set </font>
<a name="line56"> 56: </a><font color="#B22222">  */</font>
<a name="line57"> 57: </a>  <A href="../../../../../docs/manualpages/IS/ISGetLocalSize.html#ISGetLocalSize">ISGetLocalSize</A>(is,&amp;n);

<a name="line59"> 59: </a>  <font color="#B22222">/*</font>
<a name="line60"> 60: </a><font color="#B22222">     Get the indices in the index set</font>
<a name="line61"> 61: </a><font color="#B22222">  */</font>
<a name="line62"> 62: </a>  <A href="../../../../../docs/manualpages/IS/ISGetIndices.html#ISGetIndices">ISGetIndices</A>(is,&amp;indices);
<a name="line63"> 63: </a>  <font color="#B22222">/*</font>
<a name="line64"> 64: </a><font color="#B22222">     Now any code that needs access to the list of integers</font>
<a name="line65"> 65: </a><font color="#B22222">   has access to it here through indices[].</font>
<a name="line66"> 66: </a><font color="#B22222">   */</font>
<a name="line67"> 67: </a>  <A href="../../../../../docs/manualpages/Sys/PetscPrintf.html#PetscPrintf">PetscPrintf</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,<font color="#666666">"[%d] First index %D\n"</font>,<A href="../../../../../docs/manualpages/Sys/rank.html#rank">rank</A>,indices[0]);

<a name="line69"> 69: </a>  <font color="#B22222">/*</font>
<a name="line70"> 70: </a><font color="#B22222">     Once we no longer need access to the indices they should </font>
<a name="line71"> 71: </a><font color="#B22222">     returned to the system </font>
<a name="line72"> 72: </a><font color="#B22222">  */</font>
<a name="line73"> 73: </a>  <A href="../../../../../docs/manualpages/IS/ISRestoreIndices.html#ISRestoreIndices">ISRestoreIndices</A>(is,&amp;indices);

<a name="line75"> 75: </a>  <font color="#B22222">/*</font>
<a name="line76"> 76: </a><font color="#B22222">     One should destroy any PETSc object once one is completely</font>
<a name="line77"> 77: </a><font color="#B22222">    done with it.</font>
<a name="line78"> 78: </a><font color="#B22222">  */</font>
<a name="line79"> 79: </a>  <A href="../../../../../docs/manualpages/IS/ISDestroy.html#ISDestroy">ISDestroy</A>(is);
<a name="line80"> 80: </a>  <A href="../../../../../docs/manualpages/Sys/PetscFinalize.html#PetscFinalize">PetscFinalize</A>();
<a name="line81"> 81: </a>  <font color="#4169E1">return</font> 0;
<a name="line82"> 82: </a>}
<a name="line83"> 83: </a>
</pre>
</body>

</html>
